unit jvTipsComboBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TTipSelected=procedure (index:integer; AName,ATip:string) of object;
  TjvTipsComboBox = class(TComboBox)
  private
    FTips:TStringlist;
    FFileName: string;
    FonTipSelected: TTipSelected;
  procedure SetFileName(const Value: string);
  procedure UpdateCombo;
    procedure SetonTipSelected(const Value: TTipSelected);
    { Private declarations }
  protected
    { Protected declarations }
    procedure LoadTips;
    procedure SaveTips;
    procedure Click;override;
    procedure  KeyDown(var Key: Word; Shift: TShiftState);override;
    procedure CreateWnd; override;
  public
    { Public declarations }
    constructor create(AOwner:TComponent);override;
    destructor destroy;override;
    procedure SetTipByName(AName,ATip:string);
    procedure SetTip(ATip:string);
    function GetTipByName(AName:string):string;
    procedure ClearAllTips;
    procedure FindTipNames(var aList:TStrings;FindText:string);
  published
    { Published declarations }
    property FileName:string read FFileName write SetFileName;
    property onTipSelected:TTipSelected read FonTipSelected write SetonTipSelected;
  end;

procedure Register;

implementation

const
  cr = chr(13)+chr(10);
  tab = chr(9);


procedure Register;
begin
  RegisterComponents('Jans 2', [TjvTipsComboBox]);
end;

{ TjvTipsComboBox }

procedure TjvTipsComboBox.Click;
var index,p:integer;
    s,AName,ATip:string;
begin
  inherited;
  index:=itemindex;
  if index<>-1 then begin
   s:=FTips[index];
   p:=pos('=',s);
   if p>0 then begin
    AName:=copy(s,1,p-1);
    ATip:=copy(s,p+1,length(s));
    Atip:=stringreplace(ATip,'~~',cr,[rfreplaceall]);
    if assigned(onTipSelected) then
     onTipSelected(index,Aname,ATip);
    end;
   end;
  if assigned(onclick) then
   onclick(self);
end;

constructor TjvTipsComboBox.create(AOwner: TComponent);
begin
  inherited create(AOwner);
  FTips:=Tstringlist.create;
end;

destructor TjvTipsComboBox.destroy;
begin
  if not (csDesigning in componentstate) then SaveTips;
  FTips.free;
  inherited;
end;


procedure TjvTipsComboBox.LoadTips;
var appldir:string;
    tipfile:string;
    i:integer;
begin
  appldir:=extractfilepath(application.exename);
  if FileName='' then exit;
  tipfile:=appldir+FileName;
  if not fileexists(tipfile) then exit;
  FTips.LoadFromFile (tipfile);
  FTips.Sort ;
  UpdateCombo;
end;

function TjvTipsComboBox.GetTipByName(AName:string): string;
var index,p:integer;
    s:string;
begin
  result:='';
  index:=FTips.IndexOfName (AName);
  if index=-1 then exit;
  s:=FTips[index];
  p:=pos('=',s);
  if p=0 then exit;
  s:=copy(s,p+1,length(s));
  result:=stringreplace(s,'~~',cr,[rfreplaceall]);
end;

procedure TjvTipsComboBox.SaveTips;
var appldir:string;
    tipfile:string;
    i:integer;
begin
  appldir:=extractfilepath(application.exename);
  if FileName='' then exit;
  tipfile:=appldir+FileName;
  FTips.SavetoFile (tipfile);

end;

procedure TjvTipsComboBox.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

procedure TjvTipsComboBox.SetonTipSelected(const Value: TTipSelected);
begin
  FonTipSelected := Value;
end;

procedure TjvTipsComboBox.UpdateCombo;
var i:integer;
begin
  Clear;
  if Ftips.count=0 then exit;
  for i:=0 to FTips.count-1 do
   items.Append (FTips.names[i]);
end;

procedure TjvTipsComboBox.SetTipByName(AName, ATip: string);
var index:integer;
begin
 if AName='' then exit;
 ATip:=stringreplace(ATip,cr,'~~',[rfreplaceall]);
 index:=FTips.IndexOfName (Aname);
 if index=-1 then begin
  if ATip<>'' then
   FTips.Append (Aname+'='+Atip);
  end
  else begin
  if ATip<>'' then
   FTips[index]:=AName+'='+Atip
   else
   FTips.Delete (index);
  end;
 FTips.Sort ;
 UpdateCombo;
end;

procedure TjvTipsComboBox.ClearAllTips;
begin
 FTips.clear;
 Clear;
end;

procedure TjvTipsComboBox.FindTipNames(var aList: TStrings;
  FindText: string);
var i:integer;
begin
 Alist.Clear ;
 if Ftips.Count =0 then exit;
 FindText:=lowercase(FindText);
 for i:=0 to Ftips.count-1 do
  if findtext='' then
   Alist.append(FTips.names[i])
  else if pos(Findtext,lowercase(FTips[i]))>0 then
   Alist.append(FTips.names[i])
end;

procedure TjvTipsComboBox.CreateWnd;
begin
  inherited;
  if not (csDesigning in componentstate) then LoadTips;
end;

procedure TjvTipsComboBox.SetTip(ATip: string);
var index:integer;
    s:string;
begin
 index:=ItemIndex ;
 s:='';
 if index<>-1 then s:=FTips.names[index];
 s:=inputbox('Update Tips','Enter Tip Name',s);
 SetTipByName (s,ATip);
end;


procedure TjvTipsComboBox.KeyDown(var Key: Word; Shift: TShiftState);
var match:TStringlist;
begin
  inherited;
  if key=vk_return then begin
   key:=0;
   match:=tstringlist.create;
   FindTipNames(TStrings(match),Text);
   items.assign(match);
   match.free;
   end;
  if assigned (onkeydown) then
   onkeydown(self, key, shift);

end;

end.
